#include "stdafx.h"

void StringTest(){
    String str1 = L"123<,><,><,>`ab<,>";
    String str2 = L"123,,,`ab";
    String str3 = L" \n<hoge>\r ";
    String str4 = L"ABC";

    // Replace
    BOOST_CHECK(str1.Replace(L"<,>", L",") == str2 + L",");
    BOOST_CHECK(str1.Replace(L"<", L"").Replace(L">", L"") == str2 + L",");
    BOOST_CHECK(str1.Replace(L">", L"").Replace(L"<", L"") == str2 + L",");
    BOOST_CHECK(str2.Replace(L",", L"<,>") + L"<,>" == str1);

    // Split, Join
    BOOST_CHECK(string::Join(L"<,>", str1.Split(Array<string>(L"<,>"))) == str1);
    BOOST_CHECK(str1.Split(Array<string>(L"<,>")).GetCount() == 5);
    BOOST_CHECK(str1.Split(Array<string>(L"<,>"))[2] == L"");
    BOOST_CHECK(str1.Split(Array<string>(L"<,>"), 100, StringSplitOptions::RemoveEmptyEntries).GetCount() == 3);
    BOOST_CHECK(str1.Split(Array<string>(L"<,>"), 2, StringSplitOptions::RemoveEmptyEntries)[1] == L"<,><,>`ab<,>");

    BOOST_CHECK(string::Join(L",", str2.Split(Array(L','))) == str2);
    BOOST_CHECK(str2.Split(Array(L',')).GetCount() == 4);
    BOOST_CHECK(str2.Split(Array(L','))[2] == L"");
    BOOST_CHECK(str2.Split(Array(L','), 100, StringSplitOptions::RemoveEmptyEntries).GetCount() == 3);
    BOOST_CHECK(str2.Split(Array(L','), 2, StringSplitOptions::RemoveEmptyEntries)[1] == L",,`ab");

    // Trim, TrimStart, TrimEnd
    BOOST_CHECK(str3.TrimStart() == L"<hoge>\r ");
    BOOST_CHECK(str3.TrimEnd() == L" \n<hoge>");
    BOOST_CHECK(str3.Trim() == L"<hoge>");
    BOOST_CHECK(str3.TrimStart(Array(L' ', L'\r', L'\n')) == L"<hoge>\r ");
    BOOST_CHECK(str3.TrimEnd(Array(L' ', L'\r', L'\n')) == L" \n<hoge>");
    BOOST_CHECK(str3.Trim(Array(L' ', L'\r', L'\n')) == L"<hoge>");

    // IndexOf, LastIndexOf
    BOOST_CHECK_EQUAL(str4.IndexOf(L'D'), -1);
    BOOST_CHECK_EQUAL(str4.IndexOf(L''), 0);
    BOOST_CHECK_EQUAL(str4.IndexOf(L''), 11);
    BOOST_CHECK_EQUAL(str4.IndexOf(L"DC"), -1);
    BOOST_CHECK_EQUAL(str4.IndexOf(L""), 10);
    BOOST_CHECK_EQUAL(str4.LastIndexOf(L'D'), -1);
    BOOST_CHECK_EQUAL(str4.LastIndexOf(L''), 0);
    BOOST_CHECK_EQUAL(str4.LastIndexOf(L''), 11);
    BOOST_CHECK_EQUAL(str4.LastIndexOf(L"DC"), -1);
    BOOST_CHECK_EQUAL(str4.LastIndexOf(L""), 10);

    // ToUpper, ToLower
    BOOST_CHECK(str4.ToUpper() == L"`abABC");
    BOOST_CHECK(str4.ToLower() == L"abc");
    BOOST_CHECK(str4.ToLower() == string(L"`abABC").ToLower());
}

