#include "stdafx.h"
#include "ArchiverDll.h"
#include "7ZipArchiver.h"
namespace Themis {

C7ZipArchiver::C7ZipArchiver() {
}

C7ZipArchiver::~C7ZipArchiver() {
}

vector<string> C7ZipArchiver::InnerGetSupportedSuffixes() const {
    vector<string> vct;
    if (CArchiverDll::Get7Zip().IsReady()) {
        vct.push_back(L"zip");
        vct.push_back(L"7z");
    }
    return vct;
}

bool C7ZipArchiver::InnerOpen(vector<SFile>& rList) {
    try {
        CArchiverDll& rDll = CArchiverDll::Get7Zip();
        if (rDll.IsReady()) {
            std::tr1::shared_ptr<CArchiverDll::CFindFile> pFinder = rDll.FindFile(NULL, GetName(),
                0x00000200L | 0x00800000L | 0x02000000L | 0x08000000L);
                // M_CHECK_FILENAME_ONLY, M_ERROR_MESSAGE_OFF, M_BAR_WINDOW_OFF, M_RECOVERY_ON
                // tO͖Ă͂ǔÔ
            if (pFinder != NULL) {
                // \bhɂǂ̔
                Detail::ULHA_INT64 size;
                if (rDll.GetArcCompressedSizeEx(*pFinder, size) && size < 0) {
                    type = eTypeSolid; //  ߂lTRUEŃTCY == -1Ȃ\bh
                } else {
                    type = eTypeNormal;
                }
                // t@C̎擾
                do {
                    if (!CFileName(Encoding::GetDefault().GetString(pFinder->GetInfo().szFileName)).IsDirPath()) {
                        rList.push_back(SFile(pFinder->GetInfo()));
                    }
                } while (pFinder->ToNext());
                return true;
            }
        }
    } catch (std::exception&) {
    }
    return false;
}

void C7ZipArchiver::InnerExtractAll(const CFileName& oDirName, bool showProgress) {
    CArchiverDll& rDll = CArchiverDll::Get7Zip();
    if (rDll.IsReady()) {
        string strCmd = L"x -aos"; //𓀁A㏑sȂ
        if (!showProgress) {
            strCmd += L" -hide"; // _CAO
        }
        strCmd += L" \"" + GetName() + L"\"";
        strCmd += L" -o\"" + oDirName.Get() + L"\""; // o̓fBNgwIvV
        rDll.Command(NULL, strCmd);
    }
}

void C7ZipArchiver::InnerExtractFile(int nFileIndex, const CFileName& oDirName) {
    CArchiverDll& rDll = CArchiverDll::Get7Zip();
    if (rDll.IsReady()) {
        string strCmd = L"x -aos -hide"; //𓀁A㏑sȂA_CAO
        strCmd += L" \"" + GetName() + L"\"";
        strCmd += L" -o\"" + oDirName.Get() + L"\""; // o̓fBNgwIvV
        strCmd += L" \"" + GetFileName(nFileIndex) + L"\"";
     // strCmd += L" \"" + CFileName(GetFileName(nFileIndex)).GetPureName() + L"\"";
        rDll.Command(NULL, strCmd);
    }
}

void C7ZipArchiver::InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData) {
    ExtractLoad(nFileIndex, vctData);
}

void C7ZipArchiver::ConfigDialog(HWND hWnd) {
    CArchiverDll& rDll = CArchiverDll::Get7Zip();
    if (rDll.IsReady()) {
        char sz[514] = {0};
        rDll.ConfigDialog(hWnd, sz);
    }
}

}
