#include "stdafx.h"
#include "ArchiverDll.h"
#include "UnGcaArchiver.h"
namespace Themis {

CUnGcaArchiver::CUnGcaArchiver() : solid(false) {
}

CUnGcaArchiver::~CUnGcaArchiver() {
}

vector<string> CUnGcaArchiver::InnerGetSupportedSuffixes() const {
    vector<string> vct;
    if (CArchiverDll::GetUnGca().IsReady()) {
        vct.push_back(L"gca");
    }
    return vct;
}

bool CUnGcaArchiver::InnerOpen(vector<SFile>& rList) {
    try {
        CArchiverDll& rDll = CArchiverDll::GetUnGca();
        if (rDll.IsReady()) {
            std::tr1::shared_ptr<CArchiverDll::CFindFile> pFinder = rDll.FindFile(NULL, GetName(),
                0x00000200L | 0x00800000L | 0x02000000L | 0x08000000L);
                // M_CHECK_FILENAME_ONLY, M_ERROR_MESSAGE_OFF, M_BAR_WINDOW_OFF, M_RECOVERY_ON
                // tO͖Ă͂ǔÔ
            solid = false;
            try { solid = rDll.GetMethod(*pFinder) == L"GCA1"; } catch (...) {}
            if (pFinder != NULL) {
                do {
                    if (!CFileName(Encoding::GetDefault().GetString(pFinder->GetInfo().szFileName)).IsDirPath()) {
                        rList.push_back(SFile(pFinder->GetInfo()));
                    }
                } while (pFinder->ToNext());
                return true;
            }
        }
    } catch (std::exception&) {
    }
    return false;
}

void CUnGcaArchiver::InnerExtractAll(const CFileName& oDirName, bool showProgress) {
    CArchiverDll& rDll = CArchiverDll::GetUnGca();
    if (rDll.IsReady()) {
        string strCmd = L"e -xx1"; // 𓀁AfBNgL
        if (showProgress) {
            strCmd += L" -sx1";
        }
        strCmd += L" \"" + GetName() + L"\"";
        strCmd += L" \"" + oDirName.Get() + L"\"";
        rDll.Command(NULL, strCmd);
    }
}

void CUnGcaArchiver::InnerExtractFile(int nFileIndex, const CFileName& oDirName) {
    CArchiverDll& rDll = CArchiverDll::GetUnGca();
    if (rDll.IsReady()) {
        string strCmd = L"ex -xx1"; // ʉ𓀁AfBNgL
        strCmd += L" \"" + GetName() + L"\"";
        strCmd += L" \"" + oDirName.Get() + L"\"";
        strCmd += L" \"" + GetFileName(nFileIndex) + L"\"";
        rDll.Command(NULL, strCmd);
    }
}

void CUnGcaArchiver::InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData) {
    CArchiverDll& rDll = CArchiverDll::GetUnGca();
    if (rDll.IsReady()) {
        string strCmd = L"ex -xx1"; // ʉ
        strCmd += L" \"" + GetName() + L"\"";
        strCmd += L" \"" + CFileNameModuleDir().Get() + L"\""; // WJtH_K{炵
        strCmd += L" \"" + GetFileName(nFileIndex) + L"\"";
        vctData.clear();
        vctData.resize(GetFileSize(nFileIndex));
        if (0 < vctData.size() && !rDll.ExtractMem(NULL, strCmd, &vctData[0], vctData.size())) {
            throw RuntimeException(L"'" + GetName() + L"'  '" + GetFileName(nFileIndex) + L"' ̓ǂݍ݂Ɏs܂");
        }
    }
}

IArchiver::EType CUnGcaArchiver::InnerGetType() const {
    return solid ? eTypeSolid : eTypeLoadable;
}

void CUnGcaArchiver::ConfigDialog(HWND hWnd) {
    CArchiverDll& rDll = CArchiverDll::GetUnGca();
    if (rDll.IsReady()) {
        char sz[514] = {0};
        rDll.ConfigDialog(hWnd, sz);
    }
}

}
