#include "stdafx.h"
#include "UnRarArchiver.h"
#include "ArchiverDll.h"
#include "../String/StringBuilder.h"
namespace Themis {

CUnRarArchiver::CUnRarArchiver() {
}

CUnRarArchiver::~CUnRarArchiver() {
}

vector<string> CUnRarArchiver::InnerGetSupportedSuffixes() const {
    vector<string> vct;
    if (CArchiverDll::GetUnRar().IsReady()) {
        vct.push_back(L"rar");
    }
    return vct;
}

bool CUnRarArchiver::InnerOpen(vector<SFile>& rList) {
    try {
        CArchiverDll& rDll = CArchiverDll::GetUnRar();
        if (rDll.IsReady()) {
            std::tr1::shared_ptr<CArchiverDll::CFindFile> pFinder = rDll.FindFile(NULL, GetName(),
                0x00000200L | 0x00800000L | 0x02000000L | 0x08000000L);
                // M_CHECK_FILENAME_ONLY, M_ERROR_MESSAGE_OFF, M_BAR_WINDOW_OFF, M_RECOVERY_ON
            if (pFinder != NULL) {
                do {
                    if (!CFileName(Encoding::GetDefault().GetString(pFinder->GetInfo().szFileName)).IsDirPath()) {
                        rList.push_back(SFile(pFinder->GetInfo()));
                    }
                } while (pFinder->ToNext());
                return true;
            }
        }
    } catch (std::exception&) {
    }
    return false;
}

void CUnRarArchiver::InnerExtractFile(int nFileIndex, const CFileName& oDirName) {
    CArchiverDll& rDll = CArchiverDll::GetUnRar();
    if (rDll.IsReady()) {
        StringBuilder cmd = L"-x -o- -s -q \"";   //𓀁A㏑sArA_CAO
        cmd.Append(GetName());
        cmd.Append(L"\" \"");
        cmd.Append(oDirName.Get());
        cmd.Append(L"\" \"");
        cmd.Append(GetFileName(nFileIndex));
        cmd.Append(L'\"');
        rDll.Command(NULL, cmd.ToString());
    }
}

void CUnRarArchiver::InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData) {
    ExtractLoad(nFileIndex, vctData);
}

void CUnRarArchiver::ConfigDialog(HWND hWnd) {
    CArchiverDll& rDll = CArchiverDll::GetUnRar();
    if (rDll.IsReady()) {
        char sz[514] = {0};
        rDll.ConfigDialog(hWnd, sz);
    }
}

}
