#include "stdafx.h"
#include "UnZipArchiver.h"
#include "ArchiverDll.h"
#include "../String/StringBuilder.h"
namespace Themis {

CUnZipArchiver::CUnZipArchiver() {
}

CUnZipArchiver::~CUnZipArchiver() {
}

vector<string> CUnZipArchiver::InnerGetSupportedSuffixes() const {
    vector<string> vct;
    if (CArchiverDll::GetUnZip().IsReady()) {
        vct.push_back(L"zip");
    }
    return vct;
}

bool CUnZipArchiver::InnerOpen(vector<SFile>& rList) {
    try {
        CArchiverDll& rDll = CArchiverDll::GetUnZip();
        if (rDll.IsReady()) {
            std::tr1::shared_ptr<CArchiverDll::CFindFile> pFinder = rDll.FindFile(NULL, GetName(),
                0x00000200L | 0x00800000L | 0x02000000L | 0x08000000L);
                // M_CHECK_FILENAME_ONLY, M_ERROR_MESSAGE_OFF, M_BAR_WINDOW_OFF, M_RECOVERY_ON
            if (pFinder != NULL) {
                do {
                    if (!CFileName(Encoding::GetDefault().GetString(pFinder->GetInfo().szFileName)).IsDirPath()) {
                        rList.push_back(SFile(pFinder->GetInfo()));
                    }
                } while (pFinder->ToNext());
                return true;
            }
        }
    } catch (std::exception&) {
    }
    return false;
}

namespace {
    string UnZipGetNoRegexStr(const string& str) {
        StringBuilder str2;
        for (int i = 0, n = str.GetLength(); i < n; ) {
            wchar_t c = str[i];
            if (c==L'[' || c==L']' || c==L'!' || c==L'^' || c==L'-' || c==L'\\') {
                // L'*'L'?'̓t@CƂĎgȂ̂łƂ肠ȗ
                str2.Append(L'\\');
                str2.Append(c);
                i++;
            } else {
                str2.Append(c);
                i++;
            }
        }
        return str2.ToString();
    }
}
void CUnZipArchiver::InnerExtractFile(int nFileIndex, const CFileName& oDirName) {
    CArchiverDll& rDll = CArchiverDll::GetUnZip();
    if (rDll.IsReady()) {
        StringBuilder cmd = L"-x --i -n -qq \""; //𓀁A_CAOA㏑sȂA\炷
        cmd.Append(GetName());
        cmd.Append(L"\" \"");
        cmd.Append(oDirName.Get());
        cmd.Append(L"\" \"");
        cmd.Append(UnZipGetNoRegexStr(GetFileName(nFileIndex)));
        cmd.Append(L'\"');
        rDll.Command(NULL, cmd.ToString());
    }
}

void CUnZipArchiver::InnerLoadFile(int nFileIndex, vector<uint8_t>& vctData) {
    CArchiverDll& rDll = CArchiverDll::GetUnZip();
    if (rDll.IsReady()) {
        StringBuilder cmd = L"-x --i \""; // 𓀁A_CAO
        cmd.Append(GetName());
        cmd.Append(L"\" \"");
        cmd.Append(UnZipGetNoRegexStr(GetFileName(nFileIndex)));
        cmd.Append(L'\"');
        vctData.clear();
        vctData.resize(GetFileSize(nFileIndex));
        if (0 < vctData.size() && !rDll.ExtractMem(NULL, cmd.ToString(), &vctData[0], vctData.size())) {
            throw RuntimeException(L"'" + GetName() + L"'  '" + GetFileName(nFileIndex) + L"' ̓ǂݍ݂Ɏs܂");
        }
    }
}

void CUnZipArchiver::ConfigDialog(HWND hWnd) {
    CArchiverDll& rDll = CArchiverDll::GetUnZip();
    if (rDll.IsReady()) {
        char sz[514] = {0};
        rDll.ConfigDialog(hWnd, sz);
    }
}

}
