#include "../Rand.h"
#include "../Calculator.h"
#include "../Utility/Algorithm.h"
#include "../Utility/StringUtility.h"
#include <math.h>
#include <float.h>  // DBL_MAXƂ
namespace Themis {
namespace {

static bool func_rand(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    switch (rParams.GetCount()) {
    case 0:
        rRet = static_cast<int>(CRand::GetInstance()(0x40000000)); //ꂵȂxɁBB
        break;
    case 1:
        if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
        else {
            CRand& rRand = CRand::GetInstance();
            rRet = static_cast<double>(rRand()) / rRand.GetMax() * rParams.GetFloat(0);
        }
        break;
    case 2:
        if (!rParams.CheckType(false, false)) { rOwner.OnError(strFunc + L"()̈sł"); }
        else {
            rRet = static_cast<int>(CRand::GetInstance()(rParams.GetInt(0), rParams.GetInt(1)));
        }
        break;
    default:
        rOwner.OnError(L"rand()̈̐sł");
        return false;
    }
    return true;
}

static bool func_int(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetInt(0);
        return true;
    }
    return false;
}

static bool func_float(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetFloat(0);
        return true;
    }
    return false;
}

static bool func_floor(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = floor(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_ceil(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = ceil(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_abs(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        if (rParams.GetType(0) == 0) {
            rRet = abs(rParams.GetInt(0));
        }
        else {
            rRet = fabs(rParams.GetFloat(0));
        }
        return true;
    }
    return false;
}

static bool func_sqrt(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = sqrt(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_sin(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = sin(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_cos(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = cos(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_tan(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = tan(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_asin(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = asin(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_acos(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = acos(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_atan(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = atan(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_sinh(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = sinh(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_cosh(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = cosh(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_tanh(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = tanh(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_log(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = log(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_log10(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = log10(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_exp(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = exp(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_min(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false, false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        if (Max(rParams.GetType(0), rParams.GetType(1)) == 0) {
            rRet = Min(rParams.GetInt(0), rParams.GetInt(1));
        }
        else {
            rRet = Min(rParams.GetFloat(0), rParams.GetFloat(1));
        }
        return true;
    }
    return false;
}

static bool func_max(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false, false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        if (Max(rParams.GetType(0), rParams.GetType(1)) == 0) {
            rRet = Max(rParams.GetInt(0), rParams.GetInt(1));
        }
        else {
            rRet = Max(rParams.GetFloat(0), rParams.GetFloat(1));
        }
        return true;
    }
    return false;
}

static bool func_pow(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false, false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = pow(rParams.GetFloat(0), rParams.GetFloat(1));
        return true;
    }
    return false;
}

static bool func_atan2(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false, false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = atan2(rParams.GetFloat(0), rParams.GetFloat(1));
        return true;
    }
    return false;
}

static bool func_atoi(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = AtoI(rParams.GetStr(0));
        return true;
    }
    return false;
}

static bool func_atof(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = AtoF(rParams.GetStr(0));
        return true;
    }
    return false;
}

static bool func_length(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetStr(0).GetLength();
        return true;
    }
    return false;
}

static bool func_indexof(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true, true)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetStr(0).IndexOf(rParams.GetStr(1));
        return true;
    }
    return false;
}

static bool func_lastindexof(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true, true)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetStr(0).LastIndexOf(rParams.GetStr(1));
        return true;
    }
    return false;
}

static bool func_itoa(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = ItoA(rParams.GetInt(0));
        return true;
    }
    return false;
}

static bool func_ftoa(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = FtoA(rParams.GetFloat(0));
        return true;
    }
    return false;
}

static bool func_tolower(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetStr(0).ToLower();
        return true;
    }
    return false;
}

static bool func_toupper(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetStr(0).ToUpper();
        return true;
    }
    return false;
}

static bool func_trim(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetStr(0).Trim();
        return true;
    }
    return false;
}

static bool func_at(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true, false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetStr(0).Substring(rParams.GetInt(1), 1);
        return true;
    }
    return false;
}

static bool func_replace(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true, true, true)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetStr(0).Replace(rParams.GetStr(1), rParams.GetStr(2));
        return true;
    }
    return false;
}

static bool func_Substring(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true, false, false)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetStr(0).Substring(rParams.GetInt(1), rParams.GetInt(2));
        return true;
    }
    return false;
}

static bool func_startswith(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true, true)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetStr(0).StartsWith(rParams.GetStr(1));
        return true;
    }
    return false;
}

static bool func_endswith(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true, true)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rParams.GetStr(0).EndsWith(rParams.GetStr(1));
        return true;
    }
    return false;
}

static bool func_defined(CCalculator& rOwner, const string& strFunc, CVariable& rRet, const CVariableArray& rParams) {
    if (!rParams.CheckType(true)) { rOwner.OnError(strFunc + L"()̈sł"); }
    else {
        rRet = rOwner.IsDefinedVariable(rParams.GetStr(0)) ? 1 : 0;
        return true;
    }
    return false;
}

//------------------------------------------------------------------//

static void RegisterFunctions(std::map<string, std::tr1::shared_ptr<ICalculatorFunc> >& rList) {
    rList.insert(make_pair(L"rand", new CCalculatorFunc(&func_rand)));
    rList.insert(make_pair(L"int", new CCalculatorFunc(&func_int)));
    rList.insert(make_pair(L"float", new CCalculatorFunc(&func_float)));
    rList.insert(make_pair(L"floor", new CCalculatorFunc(&func_floor)));
    rList.insert(make_pair(L"ceil", new CCalculatorFunc(&func_ceil)));
    rList.insert(make_pair(L"abs", new CCalculatorFunc(&func_abs)));
    rList.insert(make_pair(L"sqrt", new CCalculatorFunc(&func_sqrt)));
    rList.insert(make_pair(L"sin", new CCalculatorFunc(&func_sin)));
    rList.insert(make_pair(L"cos", new CCalculatorFunc(&func_cos)));
    rList.insert(make_pair(L"tan", new CCalculatorFunc(&func_tan)));
    rList.insert(make_pair(L"asin", new CCalculatorFunc(&func_asin)));
    rList.insert(make_pair(L"acos", new CCalculatorFunc(&func_acos)));
    rList.insert(make_pair(L"atan", new CCalculatorFunc(&func_atan)));
    rList.insert(make_pair(L"sinh", new CCalculatorFunc(&func_sinh)));
    rList.insert(make_pair(L"cosh", new CCalculatorFunc(&func_cosh)));
    rList.insert(make_pair(L"tanh", new CCalculatorFunc(&func_tanh)));
    rList.insert(make_pair(L"log", new CCalculatorFunc(&func_log)));
    rList.insert(make_pair(L"log10", new CCalculatorFunc(&func_log10)));
    rList.insert(make_pair(L"exp", new CCalculatorFunc(&func_exp)));
    rList.insert(make_pair(L"min", new CCalculatorFunc(&func_min)));
    rList.insert(make_pair(L"max", new CCalculatorFunc(&func_max)));
    rList.insert(make_pair(L"pow", new CCalculatorFunc(&func_pow)));
    rList.insert(make_pair(L"atan2", new CCalculatorFunc(&func_atan2)));
    rList.insert(make_pair(L"atoi", new CCalculatorFunc(&func_atoi)));
    rList.insert(make_pair(L"atof", new CCalculatorFunc(&func_atof)));
    rList.insert(make_pair(L"length", new CCalculatorFunc(&func_length)));
    rList.insert(make_pair(L"indexof", new CCalculatorFunc(&func_indexof)));
    rList.insert(make_pair(L"lastindexof", new CCalculatorFunc(&func_lastindexof)));
    rList.insert(make_pair(L"itoa", new CCalculatorFunc(&func_itoa)));
    rList.insert(make_pair(L"ftoa", new CCalculatorFunc(&func_ftoa)));
    rList.insert(make_pair(L"tolower", new CCalculatorFunc(&func_tolower)));
    rList.insert(make_pair(L"toupper", new CCalculatorFunc(&func_toupper)));
    rList.insert(make_pair(L"trim", new CCalculatorFunc(&func_trim)));
    rList.insert(make_pair(L"at", new CCalculatorFunc(&func_at)));
    rList.insert(make_pair(L"replace", new CCalculatorFunc(&func_replace)));
    rList.insert(make_pair(L"Substring", new CCalculatorFunc(&func_Substring)));
    rList.insert(make_pair(L"startswith", new CCalculatorFunc(&func_startswith)));
    rList.insert(make_pair(L"endswith", new CCalculatorFunc(&func_endswith)));
    rList.insert(make_pair(L"defined", new CCalculatorFunc(&func_defined)));
}

}//namespace
}
