#include "stdafx.h"
#include "CommandLine.h"
#include "File.h"
#include "Windows/Environment.h"
#ifndef NDEBUG
#include "Windows/System.h"
#endif
#include "String/Encoding.h"
namespace Themis {

CCommandLine::CCommandLine(int argc, char* argv[]) {
    m_vctCommand.resize(argc - 1);
    for (size_t i = 0, n = m_vctCommand.size(); i < n; i++) {
        m_vctCommand[i] = Encoding::GetDefault().GetString(argv[i + 1]);
    }
}

CCommandLine::CCommandLine(int argc, wchar_t* argv[]) {
    m_vctCommand.resize(argc - 1);
    for (size_t i = 0, n = m_vctCommand.size(); i < n; i++) {
        m_vctCommand[i] = argv[i + 1];
    }
}

CCommandLine::CCommandLine(LPCSTR pszCmdLine) {
    if (pszCmdLine != NULL && pszCmdLine[0] != '\0') {
        // Ȃ獂̂ߏȗĂ݂B
        m_vctCommand = Environment::GetCommandLineArgs();
        /// ԍŏ͎̂st@Ĉ͂BB
        Themis_DebugAssert(CFileName(m_vctCommand[0]).GetPureName() ==
            CFileName(CSystem::GetModuleFileName()).GetPureName());
        Themis_DebugAssert(2 <= m_vctCommand.size());
        m_vctCommand.erase(m_vctCommand.begin());
    }
}

CCommandLine::CCommandLine(LPCWSTR pszCmdLine) {
    if (pszCmdLine != NULL && pszCmdLine[0] != L'\0') {
        // Ȃ獂̂ߏȗĂ݂B
        m_vctCommand = Environment::GetCommandLineArgs();
        /// ԍŏ͎̂st@Ĉ͂BB
        Themis_DebugAssert(CFileName(m_vctCommand[0]).GetPureName() ==
            CFileName(CSystem::GetModuleFileName()).GetPureName());
        Themis_DebugAssert(2 <= m_vctCommand.size());
        m_vctCommand.erase(m_vctCommand.begin());
    }
}

CCommandLine::~CCommandLine() {
}

CFileName CCommandLine::GetFileName(int i, const CFileName& oBaseDir) const {
    Themis_DebugAssert(oBaseDir.IsDirPath());
    CFileName oFileName(Get(i), oBaseDir);
    return CFile::SetDirSeparator(oFileName);
}

vector<CFileName> CCommandLine::GetFileNames(const CFileName& oBaseDir) const {
    vector<CFileName> vct(GetCount());
    for (int i = 0, n = GetCount(); i < n; i++) {
        vct[i] = GetFileName(i, oBaseDir);
    }
    return vct;
}

}
