#include "stdafx.h"
#include "MsgHook.h"
#include "DialogResizer.h"
namespace Themis {

CDialogResizer::CDialogResizer(HWND hWnd): m_hDialog(hWnd) {
}

CDialogResizer::~CDialogResizer() {
}

void CDialogResizer::Add(int nCtrl, int nLOrg, int nTOrg, int nROrg, int nBOrg) {
    Themis_DebugAssert(nLOrg == 0 || nLOrg == 1);
    Themis_DebugAssert(nTOrg == 0 || nTOrg == 1);
    Themis_DebugAssert(nROrg == 0 || nROrg == 1);
    Themis_DebugAssert(nBOrg == 0 || nBOrg == 1);
    SCtrl c;
    c.hCtrl = ::GetDlgItem(m_hDialog, nCtrl);
    c.abOrg[0] = nLOrg == 0;
    c.abOrg[1] = nTOrg == 0;
    c.abOrg[2] = nROrg == 0;
    c.abOrg[3] = nBOrg == 0;
    // _̋vZ
    CRect rcDialog, rcCtrl;
    ::GetWindowRect(m_hDialog, &rcDialog);
    ::GetWindowRect(c.hCtrl, &rcCtrl);
    c.anDist[0] = rcCtrl.left   - (c.abOrg[0]? rcDialog.left: rcDialog.right);
    c.anDist[1] = rcCtrl.top    - (c.abOrg[1]? rcDialog.top: rcDialog.bottom);
    c.anDist[2] = rcCtrl.right  - (c.abOrg[2]? rcDialog.left: rcDialog.right);
    c.anDist[3] = rcCtrl.bottom - (c.abOrg[3]? rcDialog.top: rcDialog.bottom);
    m_vctCtrl.push_back(c);
}

void CDialogResizer::OnSize(CMsgHookPrms& rPrms) {
    if (m_hDialog == rPrms.GetWnd()) { // ÔߓmF
        CRect rcDialog, rcCtrl;
        ::GetWindowRect(m_hDialog, &rcDialog);
        CPoint ptDialog(0, 0);
        ::ClientToScreen(m_hDialog, &ptDialog);
        rcDialog.left -= ptDialog.x;
        rcDialog.top -= ptDialog.y;
        rcDialog.right -= ptDialog.x;
        rcDialog.bottom -= ptDialog.y;
        for (size_t i = 0, n = m_vctCtrl.size(); i < n; i++) {
            const SCtrl& c = m_vctCtrl[i];
            rcCtrl.left     = c.anDist[0] + (c.abOrg[0]? rcDialog.left: rcDialog.right);
            rcCtrl.top      = c.anDist[1] + (c.abOrg[1]? rcDialog.top: rcDialog.bottom);
            rcCtrl.right    = c.anDist[2] + (c.abOrg[2]? rcDialog.left: rcDialog.right);
            rcCtrl.bottom   = c.anDist[3] + (c.abOrg[3]? rcDialog.top: rcDialog.bottom);
            ::SetWindowPos(c.hCtrl, NULL, rcCtrl.left, rcCtrl.top, rcCtrl.GetWidth(), rcCtrl.GetHeight(), SWP_NOZORDER);
        }
        ::InvalidateRect(m_hDialog, NULL, FALSE);
    }
}

}
