#pragma once
namespace Themis {

class CDirObserver;

/// C^[tF[X
class IDirFileList : private boost::noncopyable {
public:
    virtual ~IDirFileList() {}
    virtual int GetType() const = 0;
    virtual void Begin(const CFileName& oDirName, int nReflexive = -1) = 0;
    virtual int GetCount() = 0;
    virtual const CFileName& Get(int n) = 0;
    virtual void End() = 0;
};


/// ȃ^Cvȃt@CXg
class CDirFileList : public IDirFileList {
public:
    CDirFileList();
    ~CDirFileList();

    int GetType() const { return 0; }
    void Begin(const CFileName& oDirName, int nReflexive = -1);
    int GetCount();
    const CFileName& Get(int n);
    void End();

private:
    auto_ptr<vector<CFileName> >    m_pFileList;
};


/// ȃGl^Cvȃt@CXg
class CDirFileListCache : public IDirFileList {
public:
    CDirFileListCache();
    ~CDirFileListCache();

    int GetType() const { return 1; }
    void Begin(const CFileName& oDirName, int nReflexive = -1);
    int GetCount();
    const CFileName& Get(int n);
    void End();

private:
    auto_ptr<CDirFileList>  m_pFileList;
    auto_ptr<CDirObserver>  m_pObserver;
};


}
