#pragma once
#include "FileBase.h"
#include "String/StringBuilder.h"
namespace Themis {

class CFindFile;

/**
    t@CƂt@C̕񏈗Ƃ쏑ɂƂB
*/
class CFile : private boost::noncopyable {
    CFileName   m_oFileName;
public:
    CFile(const CFileName& oFileName) : m_oFileName(oFileName) {}
    ~CFile() {}

    /// t@C̎擾
    const CFileName& GetName() const { return m_oFileName; }
    /// t@CfBNĝ݂ǂ
    bool Exists();
    /// t@Ĉ݂ǂ
    bool ExistsFile();
    /// fBNĝ݂ǂ
    bool ExistsDir();
    /// t@C̑傫擾
    size_t GetSize();
    /// t@C̑傫擾
    uint64_t GetSize64();
    /// t@C̍ŏIXV擾
    FILETIME GetLastUpdate();
    /// ǂݍݐpȂ̂ǂ
    bool IsReadOnly();
    /// ǂݍݐpɂ
    void SetReadOnly(bool bOnly);
    /// t@C̃Rs[
    void Copy(const CFileName& oDstName) { InnerCopy(oDstName, false); }
    /// t@C̃Rs[(㏑s)
    void CopyOverwrite(const CFileName& oDstName) { InnerCopy(oDstName, true); }
    /// t@C̕ύX
    void Move(const CFileName& oDstName);
    /** t@CEfBNg̍폜
        @param  bDeleteForce    ǂ݂ƂpłIɍ폜邩ǂ */
    void Delete(bool bDeleteForce = false);
    /// ۂ̃tH_݂̂ċAIɍ폜
    void DeleteEmpty();
    /// fBNg̍쐬(ċAIɕ̃fBNg쐬\)
    void CreateDir();

    //@{ ꊇǂݏBŘ̃t@C|C^̈ʒu͖`ƂB
    void Save(const void* p, size_t n);
    void Save(const vector<uint8_t>& vct);
    void Save(const string& str);
    void Save(const std::string& str) { Save(str.c_str(), str.length()); }
    void Load(vector<uint8_t>& rMemory);
    void Load(StringBuilder& str);
    inline vector<uint8_t> LoadBin() {
        vector<uint8_t> oMemory;
        Load(oMemory);
        return oMemory;
    }
    inline string LoadStr() {
        StringBuilder str;
        Load(str);
        return str.ToString();
    }
    //@}

    /** t@C
        @param oDirName     JnfBNg
        @param nReflexive   ċA(OōċAAlŖɍċA)
        @return             t@C(FullName)̃Xg */
    static vector<CFileName> FindFile(const CFileName& oDirName, int nReflexive = -1);
    /** fBNg
        @param oDirName     JnfBNg
        @param nReflexive   ċA(OōċAAlŖɍċA)
        @return             fBNg(FullName)̃Xg */
    static vector<CFileName> FindDir(const CFileName& oDirName, int nReflexive = -1);
    /** t@CƃfBNg
        @param oDirName     JnfBNg
        @param nReflexive   ċA(OōċAAlŖɍċA)
        @return             t@CEfBNg(FullName)̃Xg */
    static vector<CFileName> Find(const CFileName& oDirName, int nReflexive = -1);

    // t@C
    struct SFindInfo {
        CFileName   oFileName;
        uint64_t   nFileSize;
        DWORD       nAttribute;
        FILETIME    ftLastUpdate;
        bool        bDir;
        SFindInfo() {}
        SFindInfo(const CFindFile& rFindFile);
    };

    /// oDirName݂ȂȂ̊̕Kw֍sA݂tH_ԂB[g瑶݂Ȃꍇ͋󕶎B
    static CFileName GetExistDirName(const CFileName& oDirName);

    /// I[tH_؂蕶ł͂ȂA݂tH_̖OȏꍇA؂蕶ǉ̂Ԃ
    static CFileName SetDirSeparator(const CFileName& oFileName);

private:
    void InnerCopy(const CFileName& oDstName, bool bOverwrite);
};

}
