#include "../../String/Encoding.h"
namespace Themis {

CFontStyle::CFontStyle() : /*m_strFace(string()),*/ m_nHeight(20),
m_nWeight(eWeightNormal), m_rgbColor(RGB(0xff, 0xff, 0xff)), m_nFlags(0),
m_nShadowType(1), m_rgbShadow(RGB(0x00, 0x00, 0x00)), m_nShadowGap(2), m_rgbBg(RGB(0x00,0x00,0x00)),
m_nLineGap(0), m_rcPadding(2, 1, 0, 0) {
}

CFontStyle::CFontStyle(const LOGFONT& lf) : m_strFace(Encoding::GetDefault().GetString(lf.lfFaceName)), m_nHeight(lf.lfHeight),
m_nWeight(lf.lfWeight), m_rgbColor(RGB(0xff, 0xff, 0xff)), m_nFlags(0),
m_nShadowType(1), m_rgbShadow(RGB(0x00, 0x00, 0x00)), m_nShadowGap(2), m_rgbBg(RGB(0x00,0x00,0x00)),
m_nLineGap(0), m_rcPadding(2, 1, 0, 0) {
    SetItalic(lf.lfItalic != 0);
    SetUnderLine(lf.lfUnderline != 0);
    SetStrikeOut(lf.lfStrikeOut != 0);
}

CFontStyle::~CFontStyle() {
}

LOGFONT CFontStyle::GetLogFont() const {
    LOGFONT lf = {0};
    lf.lfHeight = m_nHeight;
    lf.lfWeight = m_nWeight;
    lf.lfItalic = IsItalic(); // ? TRUE : FALSE;
    lf.lfUnderline = IsUnderLine();
    lf.lfStrikeOut = IsStrikeOut();
    lf.lfCharSet = SHIFTJIS_CHARSET;
    lf.lfOutPrecision = OUT_DEFAULT_PRECIS;
    lf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
  #if 0x0400 <= WINVER  //OS̃o[W擾{ifgĂˁBB
    lf.lfQuality = NONANTIALIASED_QUALITY;
  #else
    lf.lfQuality = PROOF_QUALITY;
  #endif
    lf.lfPitchAndFamily = (DEFAULT_PITCH | FF_DONTCARE);
    StrCopy(lf.lfFaceName, lengthof(lf.lfFaceName), m_strFace);
    return lf;
}

string CFontStyle::SaveToStr() {
    // L":" Ƃ L", " ƂłtHgɂ͎gȂƎvAÔ L"\0" gBB
    //  ς茩ꂵ̂L", "ɂ
    return m_strFace + L", " +
        ItoA(m_nHeight) + L", " +
        ItoA(m_nWeight) + L", " +
        ItoA(m_rgbColor) + L", " +
        ItoA(m_nFlags) + L", " +
        ItoA(m_nShadowType) + L", " +
        ItoA(m_nShadowGap) + L", " +
        ItoA(m_rgbShadow) + L", " +
        ItoA(m_rgbBg) + L", " +
        ItoA(m_nLineGap) + L", " +
        ItoA(m_rcPadding.left) + L", " +
        ItoA(m_rcPadding.top) + L", " +
        ItoA(m_rcPadding.right) + L", " +
        ItoA(m_rcPadding.bottom);
}

void CFontStyle::LoadFromStr(const string& str) {
    List<string> vct = str.Split(Array<string>(L", "));
    if (vct.size() != 14) {
        throw RuntimeException(L"tHg񂪕sł: " + str);
    }
    m_strFace = vct[0];
    m_nHeight = AtoI(vct[1]);
    m_nWeight = AtoI(vct[2]);
    m_rgbColor = AtoI(vct[3]);
    m_nFlags = AtoI(vct[4]);
    m_nShadowType = AtoI(vct[5]);
    m_nShadowGap = AtoI(vct[6]);
    m_rgbShadow = AtoI(vct[7]);
    m_rgbBg = AtoI(vct[8]);
    m_nLineGap = AtoI(vct[9]);
    m_rcPadding.left = AtoI(vct[10]);
    m_rcPadding.top = AtoI(vct[11]);
    m_rcPadding.right = AtoI(vct[12]);
    m_rcPadding.bottom = AtoI(vct[13]);
}

}
