#include "stdafx.h"
#include "Print.h"
#include "../../tpl/map_vector.h"
#include "../../String/Encoding.h"
#include <commdlg.h>
#pragma comment(lib, "comdlg32.lib")
namespace Themis {

CPrintDC::CPrintDC(const SPrintDCParam& rParam) : CDC(rParam.hdc), m_bAborted(false) {
    // StartDoc()
    DOCINFO di = {sizeof(DOCINFO)};
    di.lpszDocName = Encoding::GetDefault().GetBytes(rParam.strDocName).c_str();
    if (::StartDoc(GetHandle(), &di) <= 0) {
        throw Win32Exception(L"'" + rParam.strDocName +  L"' ̈Ɏs");
    }
}

CPrintDC::~CPrintDC() {
    if (::EndDoc(GetHandle()) <= 0) {
        Themis_DebugApiError();
    }
}

/// y[WJn
void CPrintDC::StartPage() {
    if (::StartPage(GetHandle()) <= 0) {
        throw Win32Exception(L"̊JnɎs");
    }
}

/// y[WI
void CPrintDC::EndPage() {
    if (::EndPage(GetHandle()) <= 0) {
        Themis_DebugApiError();
    }
}

/// ͈͂̃sNZ̎擾
CSize CPrintDC::GetPixelSize() const {
    Themis_DebugAssert(0 < ::GetDeviceCaps(GetHandle(), HORZRES));
    Themis_DebugAssert(0 < ::GetDeviceCaps(GetHandle(), VERTRES)); // OȉĎ͖Ǝv̂ŁBB
    return CSize(::GetDeviceCaps(GetHandle(), HORZRES), ::GetDeviceCaps(GetHandle(), VERTRES));
}

/// ͈͂̇_b̎擾(܂肠ĂɂȂȂH)
CSize CPrintDC::GetMilliMeterSize() const {
    Themis_DebugAssert(0 < ::GetDeviceCaps(GetHandle(), HORZSIZE));
    Themis_DebugAssert(0 < ::GetDeviceCaps(GetHandle(), VERTSIZE)); // OȉĎ͖Ǝv̂ŁBB
    return CSize(::GetDeviceCaps(GetHandle(), HORZSIZE), ::GetDeviceCaps(GetHandle(), VERTSIZE));
}

/// pTCỸsNZ̎擾
CSize CPrintDC::GetPhysicalPixelSize() const {
    Themis_DebugAssert(0 < ::GetDeviceCaps(GetHandle(), PHYSICALWIDTH));
    Themis_DebugAssert(0 < ::GetDeviceCaps(GetHandle(), PHYSICALHEIGHT)); // OȉĎ͖Ǝv̂ŁBB
    return CSize(::GetDeviceCaps(GetHandle(), PHYSICALWIDTH), ::GetDeviceCaps(GetHandle(), PHYSICALHEIGHT));
}

/// p̍Ə㑤̃}[W̃sNZ̎擾
CRect CPrintDC::GetPhysicalMarginPixelSize() const {
    CSize szPixel = GetPixelSize();
    CSize szPPixel = GetPhysicalPixelSize();
    CRect rc;
    rc.left = ::GetDeviceCaps(GetHandle(), PHYSICALOFFSETX);
    rc.top = ::GetDeviceCaps(GetHandle(), PHYSICALOFFSETY);
    rc.right = szPPixel.cx - rc.left - szPixel.cx;
    rc.bottom = szPPixel.cy - rc.top - szPixel.cy;
    return rc;
}

/// ~Pʂŗp[̃}[Ww肵A`悷ׂW(sNZP)ԂB̒lBlt()ƂgOKB
CRect CPrintDC::GetMarginedPixelRect(int nL, int nT, int nR, int nB) {
    CSize szPixel = GetPixelSize();
    CSize szPPixel = GetPhysicalPixelSize();
    CRect rc;
    rc.left = ::GetDeviceCaps(GetHandle(), PHYSICALOFFSETX);
    rc.top = ::GetDeviceCaps(GetHandle(), PHYSICALOFFSETY);
    rc.right = szPPixel.cx - rc.left - szPixel.cx;
    rc.bottom = szPPixel.cy - rc.top - szPixel.cy;
    //  GetPhysicalMarginPixelSize()RsyB̍WAp[A\̈(HDC͈̔)ւ̋Ȃ͂B
    // ̂sNZPʂ֊ZB
    CSize szMM = GetMilliMeterSize();
    nL = (nL * szPixel.cx + szMM.cx / 2) / szMM.cx;
    nT = (nT * szPixel.cy + szMM.cy / 2) / szMM.cy;
    nR = (nR * szPixel.cx + szMM.cx / 2) / szMM.cx;
    nB = (nB * szPixel.cy + szMM.cy / 2) / szMM.cy;
    // }[WāARect֕ϊ
    CRect rcRet;
    rcRet.left = nL - rc.left;
    rcRet.top = nT - rc.top;
    rcRet.right = szPPixel.cx - rc.left - nR;
    rcRet.bottom = szPPixel.cy - rc.top - nB;
    Themis_DebugAssert(0 <= rcRet.left);
    Themis_DebugAssert(0 <= rcRet.top);
    Themis_DebugAssert(rcRet.right < szPixel.cx);
    Themis_DebugAssert(rcRet.bottom < szPixel.cy);
    return rcRet;
}

/// fB
void CPrintDC::SetAbort() {
    m_bAborted = true;
}

/// ̒f
void CPrintDC::Abort() {
    if (::AbortDoc(GetHandle()) == SP_ERROR) {
        throw Win32Exception(L"̒~Ɏs");
    }
}

//------------------------------------------------------------------//

struct SChoosePrinterData {
    PRINTDLG pd;
    SChoosePrinterData() : pd() {
        pd.lStructSize = sizeof(PRINTDLG);
        // t@C֏o͕sAftHguSy[WvAuIvWI{^gpsAݒfoCXCɁH
        pd.Flags = PD_DISABLEPRINTTOFILE | PD_ALLPAGES | PD_NOSELECTION
            | PD_RETURNDC | PD_USEDEVMODECOPIESANDCOLLATE;
        pd.nCopies = 1;
    }
};

CChoosePrinter::CChoosePrinter() {
}

CChoosePrinter::~CChoosePrinter() {
    // v悤ȋĈBB
    if (data->pd.hDC != NULL) {
        BOOL bRet = ::DeleteDC(data->pd.hDC);
        Themis_DebugAssertApi(bRet != FALSE);
    }
}

/// I[i[EBhE̐ݒ
void CChoosePrinter::SetOwner(HWND hWnd) {
    data->pd.hwndOwner = hWnd;
}

/// y[W͈̔͂w
void CChoosePrinter::SetPageRange(int nMin, int nMax) {
    data->pd.nMinPage = (WORD)nMin;
    data->pd.nMaxPage = (WORD)nMax;
}

/// ftHg̃y[Ẃ͈H
void CChoosePrinter::SetDefaultPage(int nStart, int nEnd) {
    data->pd.nFromPage = (WORD)nStart;
    data->pd.nToPage = (WORD)nEnd;
}

/// LZꂽfalse
bool CChoosePrinter::Show() {
    if (::PrintDlg(&data->pd) == FALSE) {
        return false; // LZƂG[Ƃ
    }
    return true;
}

/// v^HDC擾
HDC CChoosePrinter::GetDC() const {
    return data->pd.hDC;
}

/// y[W̎擾
pair<int, int> CChoosePrinter::GetPages() const {
    if (data->pd.nFromPage < data->pd.nToPage) {
        return pair<int, int>(data->pd.nFromPage, data->pd.nToPage);
    } else {
        return pair<int, int>(data->pd.nToPage, data->pd.nFromPage);
    }
}

}
