#pragma once
#include "tpl/single_list.h"
namespace Themis {

/**
    Ɩ߂lȃIuWFNgB
*/
class CMsgHookPrms : private boost::noncopyable {
public:
    CMsgHookPrms(HWND h, UINT u, WPARAM w, LPARAM l)
    : m_hWnd(h), m_uMsg(u), m_wPrm(w), m_lPrm(l) {}
    ~CMsgHookPrms() {}

    HWND GetWnd() const { return m_hWnd; }
    UINT GetMsg() const { return m_uMsg; }
    WPARAM GetWPrm() const { return m_wPrm; }
    LPARAM GetLPrm() const { return m_lPrm; }
    WORD GetWPrmLoWord() const { return LOWORD(GetWPrm()); }
    WORD GetWPrmHiWord() const { return HIWORD(GetWPrm()); }
    WORD GetLPrmLoWord() const { return LOWORD(GetLPrm()); }
    WORD GetLPrmHiWord() const { return HIWORD(GetLPrm()); }
    CPoint GetLPrmPoint() const { return MAKEPOINTS(m_lPrm); }
    LRESULT GetResult() const { return m_lRes; }
    void SetResult(LRESULT r) { m_lRes = r; }
    template<class T> inline LRESULT CallProc(T fn) {
        return fn(m_hWnd, m_uMsg, m_wPrm, m_lPrm);
    }

private:
    HWND        m_hWnd;
    UINT        m_uMsg;
    WPARAM      m_wPrm;
    LPARAM      m_lPrm;
    LRESULT     m_lRes;     //߂l
    friend class CMsgHook;
    CMsgHook*   m_pOwner;
};

//////////////////////////////////////////////////////////////////////

/**
    bZ[WIuWFNg̊NXB

    ̑̂ꍇArPrms.GetWnd()ƂgĔʁE򂷂ׂB
*/
class IMsgHooker : private boost::noncopyable {
public:
    /// m_oHookOwnerListMsgHookIuWFNg玩폜
    virtual ~IMsgHooker();
private:
    friend class CMsgHook;
    /// bZ[W̏sB߂l͏sǂB
    virtual bool HookMsg(CMsgHookPrms& rPrms) = 0;
    /// I[i[IuWFNgւ̃|C^B
    single_list<CMsgHook*>    m_oHookOwnerList;
};

//////////////////////////////////////////////////////////////////////

/**
    bZ[W֐XgŊǗׂ̃NXB

    Hook֐́AbZ[WꍇtrueԂ悤ɎB
*/
class CMsgHook : private boost::noncopyable {
public:
    CMsgHook();

    /** bZ[W
        @param  rPrms    bZ[ẄƃftHg̖߂l
        @retval true    ȏHookIuWFNgbZ[W(Hook֐trueԂ)ꍇ
        @retval false   SĂHookIuWFNgbZ[WȂ(Hook֐falseԂ)ꍇ */
    bool Dispatch(CMsgHookPrms& rPrms);

    void Add(IMsgHooker* pHook);
    void Remove(IMsgHooker* pHook);

private:
    ~CMsgHook();
    void Garbage();

private:
    typedef vector<pair<IMsgHooker*, bool> > TList;
    TList m_oList;
    bool m_bRemoved;
    int m_nDspatchDepth;
    std::tr1::shared_ptr<boost::recursive_mutex> mutex;
};


}
