#pragma once
#include "ImplData.h"
#include "String/StringBuilder.h"
namespace Themis {

/**
    ڑ\NXBT[o[ĂƂpB
*/
class ITcpConnection {
public:
    virtual ~ITcpConnection() {}
    virtual void Send(const void* p, size_t n) = 0;
    virtual int Receive(void* p, size_t n) = 0;
};

struct STcpSocketData;

/**
    TCP\PbgB
*/
class CTcpSocket {
    ImplData<STcpSocketData> data;
public:
    CTcpSocket();
    ~CTcpSocket();

    //@{ T[o[Ă鑤
    void Bind(unsigned short nPort);
    void Listen(int backlog);
    auto_ptr<ITcpConnection> Accept();
    void Close();
    //@}

    /// T[o[֐ڑ
    void Connect(const string& strServer, unsigned short nDefaultPort);
    //@{ f[^̑MƂ
    void Send(const std::string& str);
    void Send(const void* p, size_t n);
    int Receive(void* p, size_t n);
    void ReceiveLine(string& str);
    //@}
};

//------------------------------------------------------------------//

struct SUdpHostData;
struct SUdpSocketData;

/**
    UDP̐ڑ
*/
class CUdpHost {
    ImplData<SUdpHostData> data;
public:
    CUdpHost(const string& strServer, unsigned short nDefaultPort);
    ~CUdpHost();
    void* GetAddr() const;
};

/**
    UDP\PbgB
*/
class CUdpSocket {
    ImplData<SUdpSocketData> data;
public:
    CUdpSocket();
    ~CUdpSocket();

    //@{ f[^̑MƂBSNTPȃ\[Xǂ݂Kɍ̂łƐFXρB
    void Bind();
    bool Select(int nTimeout);
    void SendTo(const CUdpHost& rHost, const void* p, size_t n);
    int ReceiveFrom(const CUdpHost& rHost, void* p, size_t n);
    //@}
};

}
