#include "stdafx.h"
#include "SubClassAssistant.h"
#include "MsgHook.h"
#include "Windows/WinAPI.h"
namespace Themis {

CSubClassAssistant::CSubClassAssistant(): m_hWnd(NULL), m_fnWndProc(NULL) {
}

CSubClassAssistant::~CSubClassAssistant() {
}

void CSubClassAssistant::SubClass(HWND hWnd) {
    Themis_DebugAssert(m_hWnd == NULL);
    m_hWnd = hWnd;
    m_pUserDataOld = WarnLess_SetWindowLongPtr(m_hWnd, GWLP_USERDATA, (LONG_PTR)this);
    m_fnWndProc = (WNDPROC)WarnLess_SetWindowLongPtr(m_hWnd, GWLP_WNDPROC, (LONG_PTR)&CSubClassAssistant::SubClassWindowProc);
    Themis_DebugAssert(m_pUserDataOld == NULL);
}

void CSubClassAssistant::UnSubClass() {
    Themis_DebugAssert(m_hWnd != NULL);
    WarnLess_SetWindowLongPtr(m_hWnd, GWLP_WNDPROC, (LONG_PTR)m_fnWndProc);
    WarnLess_SetWindowLongPtr(m_hWnd, GWLP_USERDATA, m_pUserDataOld);
    m_hWnd = NULL;
}

LRESULT CALLBACK CSubClassAssistant::SubClassWindowProc(HWND hWnd, UINT uMsg, WPARAM wPrm, LPARAM lPrm) {
    CSubClassAssistant* pThis = (CSubClassAssistant*)WarnLess_GetWindowLongPtr(hWnd, GWLP_USERDATA);
    if (pThis != NULL) {
        return pThis->SubClassMsgHook(hWnd, uMsg, wPrm, lPrm);
    } else {
        Themis_DebugWarning(L"ȂCSubClassAssistantoOĂ邩");
        return ::CallWindowProc(&::DefWindowProc, hWnd, uMsg, wPrm, lPrm);
    }
}

LRESULT CSubClassAssistant::SubClassMsgHook(HWND hWnd, UINT uMsg, WPARAM wPrm, LPARAM lPrm) {
    CMsgHookPrms oPrms(hWnd, uMsg, wPrm, lPrm);
    oPrms.SetResult(0);
    if (SubClassMsgHook(oPrms)) { // ꍇ
        return oPrms.GetResult();
    } else { // Ȃꍇ
        return ::CallWindowProc(m_fnWndProc, hWnd, uMsg, wPrm, lPrm);
    }
}

}
