#pragma once
#include "../String/Encoding.h"
#include "../ErrorHandler.h"
namespace Themis {

/**
 * Xbh֌W̃[eBeBƂB
 */
class Thread : private boost::noncopyable {
    Thread();
    ~Thread();
public:
    enum EPriority {
        ePriorityCritical = THREAD_PRIORITY_TIME_CRITICAL,
        ePriorityMax = THREAD_PRIORITY_HIGHEST,
        ePriorityAbove = THREAD_PRIORITY_ABOVE_NORMAL,
        ePriorityNormal = THREAD_PRIORITY_NORMAL,
        ePriorityBelow = THREAD_PRIORITY_BELOW_NORMAL,
        ePriorityMin = THREAD_PRIORITY_LOWEST,
        ePriorityIdle = THREAD_PRIORITY_IDLE,
    };
    /// XbhDx̐ݒ
    static void SetPriority(EPriority nPriority) {
        BOOL bRet = ::SetThreadPriority(::GetCurrentThread(), nPriority);
        Themis_DebugAssertApi(bRet != FALSE);
    }
    /// XbhDx̎擾
    static EPriority GetPriority() {
        return static_cast<EPriority>(::GetThreadPriority(::GetCurrentThread()));
    }

    //@{ XbhۂɌĂԂׂB
    static void Initialize(const string& threadName) {
        Initialize();
        SetName(threadName);
    }
    static void Initialize() {
        EncodingInitializeLocale();
        CErrorHandler::RegisterOnUserThread();
    }
    //@}

    /// Xbh̐ݒ
  #ifdef NDEBUG
    static void SetName(const string& str) {}
  #else
    static void SetName(const string& str) { SetThreadName(-1, Encoding::GetDefault().GetBytes(str).c_str()); }
  #endif

private:
    /// Xbh̐ݒBȂ炱Őݒo邻ȁH
    static void SetThreadName(DWORD dwThreadID, LPCSTR szThreadName) {
        const int MS_VC_EXCEPTION = 0x406d1388;
        
        typedef struct tagTHREADNAME_INFO {
            DWORD dwType; // Must be 0x1000.
            LPCSTR szName; // Pointer to name (in user addr space).
            DWORD dwThreadID; // Thread ID (-1=caller thread).
            DWORD dwFlags; // Reserved for future use, must be zero.
        } THREADNAME_INFO;

        THREADNAME_INFO info;
        info.dwType = 0x1000;
        info.szName = szThreadName;
        info.dwThreadID = dwThreadID;
        info.dwFlags = 0;
        __try {
            ::RaiseException(MS_VC_EXCEPTION, 0, sizeof(info) / sizeof(DWORD), (DWORD*)&info);
        } __except(EXCEPTION_CONTINUE_EXECUTION) {
        }
    }
};

}
