#include "stdafx.h"
#include "Timer.h"
#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")
namespace Themis {

struct STimerData {
    bool bUseTGT;
    int nPeriodMin;
    int nRefCount;
    STimerData() {
        TIMECAPS tc = {0};
        MMRESULT rvl = ::timeGetDevCaps(&tc, sizeof(TIMECAPS));
        nPeriodMin = tc.wPeriodMin;
        bUseTGT = (rvl == TIMERR_NOERROR && nPeriodMin < 10);
        nRefCount = 0;
    }
};

STimerData& CTimer::GetData() {
    static STimerData s_oData;
    return s_oData;
}

void CTimer::Begin() {
    STimerData& r = GetData();
    if (r.bUseTGT && r.nRefCount++ <= 0) {
        ::timeBeginPeriod(r.nPeriodMin);
    }
}

void CTimer::End() {
    STimerData& r = GetData();
    if (r.bUseTGT && --r.nRefCount <= 0) {
        ::timeEndPeriod(r.nPeriodMin);
    }
}

unsigned CTimer::Get() {
    STimerData& r = GetData();
    return r.bUseTGT ? (::timeGetTime()) : (::GetTickCount());
}

void CTimer::Sleep(unsigned n) {
    ::Sleep(n);
}

void CTimer::SleepStrict(unsigned n) {
    unsigned nStart = Get();
    //::Sleep()̐x͂Ƃ肠4msȓƉ
    if (4 < n) { ::Sleep(n-4); }
    while (Get() - nStart < n)
        ;
}

}
