#pragma once
namespace Themis {

/**
    T̃f[^Ũf[^ΈɑΉꍇA
    ǂ炩łΉf[^oReiB

    STL`bNɂ肷̂ʓ|Ȃ̂ŁAƂ肠KvŒB
*/
template<class T, class U, class CT = std::less<T>, class CU = std::less<U> > class TwowayMap : private boost::noncopyable {
    typedef typename boost::call_traits<T>::param_type param_type_t;
    typedef typename boost::call_traits<U>::param_type param_type_u;
    typedef std::map<T, U, CT> map_type_t;
    typedef std::map<U, T, CU> map_type_u;
public:
    TwowayMap() {}
    ~TwowayMap() {}

    void Insert(param_type_t x, param_type_u y) {
        m_map_t.insert(make_pair(x, y));
        m_map_u.insert(make_pair(y, x));
    }

    const U* FindU(param_type_t x) const {
        map_type_t::const_iterator it = m_map_t.find(x);
        if (it != m_map_t.end()) {
            return &(*it).second;
        }
        return NULL;
    }

    const T* FindT(param_type_u x) const {
        map_type_u::const_iterator it = m_map_u.find(x);
        if (it != m_map_u.end()) {
            return &(*it).second;
        }
        return NULL;
    }

    bool IsEmpty() const {
        Themis_DebugAssert(m_map_t.empty() == m_map_u.empty());
        return m_map_t.empty();
    }

private:
    map_type_t      m_map_t;
    map_type_u      m_map_u;
};

}
