#pragma once
#include "NativeString.h"
#include <commctrl.h>
#pragma comment(lib,"comctl32.lib")
namespace Themis {

/**
 * Xgr[֘Â֐ƂB
 */
class ListViewUtility : private boost::noncopyable {
public:
    /// zXgr[ŕZbgƂB
    static void SetText(LV_DISPINFO& lvdi, const string& text) {
        if (NativeString::IsUnicode()) {
            LV_DISPINFOW& t = reinterpret_cast<LV_DISPINFOW&>(lvdi);
            SetText(t.item.pszText, t.item.cchTextMax, text);
        } else {
            LV_DISPINFOA& t = reinterpret_cast<LV_DISPINFOA&>(lvdi);
            SetText(t.item.pszText, t.item.cchTextMax, text);
        }
    }
    /// zXgr[ŕZbgƂB
    static void SetText(NMLVGETINFOTIP& lvdi, const string& text) {
        NativeString str = text;
        if (NativeString::IsUnicode()) {
            NMLVGETINFOTIPW& t = reinterpret_cast<NMLVGETINFOTIPW&>(lvdi);
            SetText(t.pszText, t.cchTextMax, str);
        } else {
            NMLVGETINFOTIPA& t = reinterpret_cast<NMLVGETINFOTIPA&>(lvdi);
            SetText(t.pszText, t.cchTextMax, str);
        }
    }

private:
    static void SetText(wchar_t* pszText, int cchTextMax, const NativeString& str) {
        int n = str.GetLength() + 1;
        if (n < cchTextMax) {
            memcpy(pszText, str.GetW(), n * sizeof(*pszText));
        } else if (4 < cchTextMax) {
            memcpy(pszText, str.GetW(), (cchTextMax - 4) * sizeof(*pszText));
            pszText[cchTextMax - 4] = L'.';
            pszText[cchTextMax - 3] = L'.';
            pszText[cchTextMax - 2] = L'.';
            pszText[cchTextMax - 1] = L'\0';
        }
    }
    static void SetText(char* pszText, int cchTextMax, const NativeString& str) {
        int n = str.GetLength() + 1;
        if (n < cchTextMax) {
            memcpy(pszText, str.GetA(), n * sizeof(*pszText));
        } else if (4 < cchTextMax) {
            memcpy(pszText, str.GetA(), (cchTextMax - 4) * sizeof(*pszText));
            pszText[cchTextMax - 4] = '.';
            pszText[cchTextMax - 3] = '.';
            pszText[cchTextMax - 2] = '.';
            pszText[cchTextMax - 1] = '\0';
        }
    }
};

}
