#include "stdafx.h"
#include "MenuStrip.h"
#include "NativeString.h"
#include "../String/Encoding.h"
namespace Themis {

/// ڂ̒ǉ
void ToolStripItemCollection::Add(const std::tr1::shared_ptr<ToolStripItem>& item) {
    items.push_back(item);
    UINT uItem = static_cast<UINT>(items.size()); // ֒ǉ

    int itemType = item->GetType();
    if (itemType == 0) {
        ToolStripMenuItem& menuItem = static_cast<ToolStripMenuItem&>(*item);
        NativeString text = menuItem.GetText();
        if (NativeString::IsUnicode()) {
            MENUITEMINFOW mii = {sizeof(mii)};
            mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_SUBMENU;
            mii.fType = MFT_STRING;
            mii.fState = menuItem.IsEnabled() ? MFS_ENABLED : MFS_GRAYED;
            mii.hSubMenu = menuItem.GetHandle();
            mii.dwTypeData = const_cast<LPWSTR>(text.GetW());
            BOOL result = ::InsertMenuItemW(handle, uItem, TRUE, &mii);
            Themis_DebugAssertApi(result != FALSE);
        } else {
            MENUITEMINFO mii = {sizeof(mii)};
            mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_SUBMENU;
            mii.fType = MFT_STRING;
            mii.fState = menuItem.IsEnabled() ? MFS_ENABLED : MFS_GRAYED;
            mii.hSubMenu = menuItem.GetHandle();
            mii.dwTypeData = const_cast<LPSTR>(text.GetA());
            BOOL result = ::InsertMenuItemA(handle, uItem, TRUE, &mii);
            Themis_DebugAssertApi(result != FALSE);
        }
    } else if (itemType == 1) {
        ToolStripTextItem& menuItem = static_cast<ToolStripTextItem&>(*item);
        NativeString text = menuItem.GetText();
        if (NativeString::IsUnicode()) {
            MENUITEMINFOW mii = {sizeof(mii)};
            mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
            mii.fType = MFT_STRING;
            mii.fState = menuItem.IsEnabled() ? MFS_ENABLED : MFS_GRAYED;
            mii.wID = menuItem.GetID();
            mii.dwTypeData = const_cast<LPWSTR>(text.GetW());
            BOOL result = ::InsertMenuItemW(handle, uItem, TRUE, &mii);
            Themis_DebugAssertApi(result != FALSE);
        } else {
            MENUITEMINFO mii = {sizeof(mii)};
            mii.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
            mii.fType = MFT_STRING;
            mii.fState = menuItem.IsEnabled() ? MFS_ENABLED : MFS_GRAYED;
            mii.wID = menuItem.GetID();
            mii.dwTypeData = const_cast<LPSTR>(text.GetA());
            BOOL result = ::InsertMenuItemA(handle, uItem, TRUE, &mii);
            Themis_DebugAssertApi(result != FALSE);
        }
    } else if (itemType == 2) {
        MENUITEMINFO mii = {sizeof(mii)};
        mii.fMask = MIIM_TYPE;
        mii.fType = MFT_SEPARATOR;
        BOOL result = ::InsertMenuItem(handle, uItem, TRUE, &mii);
        Themis_DebugAssertApi(result != FALSE);
    }
}

}
