/** @file
 * j[o[𓮓Iɐ邽߂̃NXQ
 *
 * @author aki.
 */
#pragma once
#include "../tpl/smart_ptr_vector.h"
namespace Themis {

/**
 * j[
 */
class ToolStripItem : private boost::noncopyable {
    bool enabled;
public:
    ToolStripItem() : enabled(true) {}
    virtual ~ToolStripItem() {}
    /// RTTI
    virtual int GetType() = 0;
    /// LȂ̂ǂ
    bool IsEnabled() const { return enabled; }
    /// LȂ̂ǂ
    void SetEnabled(bool b) { enabled = b; }
};

/**
 * ToolStripItem̃XgB
 */
class ToolStripItemCollection : private boost::noncopyable {
    HMENU handle;
    smart_ptr_vector<ToolStripItem> items;
public:
    ToolStripItemCollection(HMENU handle) : handle(handle) {}
    ~ToolStripItemCollection() {}

    /// ǉ
    void Add(ToolStripItem* item) {
        Add(std::tr1::shared_ptr<ToolStripItem>(item));
    }
    /// ǉ
    void Add(const std::tr1::shared_ptr<ToolStripItem>& item);

    /// ACe̎擾
    ToolStripItem& operator[](int i) { return *items[i]; }
};

/**
 * j[o[
 */
class MenuStrip : private boost::noncopyable {
    HMENU handle;
    auto_ptr<ToolStripItemCollection> items;
public:
    MenuStrip() : handle(::CreateMenu()) {
        items.reset(new ToolStripItemCollection(handle));
    }
    ~MenuStrip() {
        ::DestroyMenu(handle);
    }

    /// Tuj[ȍڂ̃Xg
    ToolStripItemCollection& GetItems() { return *items; }
    /// Tuj[ȍڂ̃Xg
    const ToolStripItemCollection& GetItems() const { return  *items; }

    /// nh
    HMENU GetHandle() const { return handle; }
};

/**
 * Tuj[
 */
class ToolStripMenuItem : public ToolStripItem {
    HMENU handle;
    string text;
    auto_ptr<ToolStripItemCollection> items;
public:
    ToolStripMenuItem() : handle(::CreatePopupMenu()) {
        items.reset(new ToolStripItemCollection(handle));
    }
    ToolStripMenuItem(string text) : handle(::CreatePopupMenu()), text(text) {
        items.reset(new ToolStripItemCollection(handle));
    }
    ~ToolStripMenuItem() {
        ::DestroyMenu(handle);
    }

    /// RTTI
    int GetType() { return 0; }

    /// nh
    HMENU GetHandle() const { return handle; }

    /// LvV
    const string& GetText() const { return text; }
    /// LvV
    void SetText(const string& t) { text = t; }

    /// Tuj[ȍڂ̃Xg
    ToolStripItemCollection& GetDropDownItems() { return *items; }
    /// Tuj[ȍڂ̃Xg
    const ToolStripItemCollection& GetDropDownItems() const { return  *items; }
};

/**
 * Tuj[ȂځB
 *
 * .NETłToolStripMenuItemƂ܂Ƃ߂Ă邪AȂƃR[fBOʓ|Ȃ̂ŁBB
 */
class ToolStripTextItem : public ToolStripItem {
    int id;
    string text;
public:
    ToolStripTextItem() {}
    ToolStripTextItem(int id, string text) : id(id), text(text) {}
    ~ToolStripTextItem() {}

    /// RTTI
    int GetType() { return 1; }

    /// ID
    int GetID() const { return id; }
    /// ID
    void SetID(int n) { id = n; }

    /// LvV
    const string& GetText() const { return text; }
    /// LvV
    void SetText(const string& t) { text = t; }
};

/**
 * Zp[^B
 */
class ToolStripSeparator : public ToolStripItem {
public:
    /// RTTI
    int GetType() { return 2; }
};

}
