#pragma once
#include "WndCtrl.h"
#include "String/Encoding.h"
namespace Themis {

/**
    HWNDւ̑nAPIbsOB

    RXgN^HWND^邩Ap
    protected: void SetHandle(HWND hWnd); B
*/
class CWnd : private boost::noncopyable {
public:
    CWnd(HWND hWnd = NULL): m_hWnd(hWnd) {}
    ~CWnd() {}

    /// ݂͑Ă̂
    bool Exists() { return (::IsWindow(m_hWnd) != FALSE); }

    bool IsEnabled() { return (::IsWindowEnabled(m_hWnd) != FALSE); }
    void SetEnabled(bool b) { ::EnableWindow(m_hWnd, b?TRUE:FALSE); }
    void ReverseEnabled() { SetEnabled(!IsEnabled()); }

    /// ĕ`
    void Update();
    /// ĕ`
    void Update(const CRect& rc);
    /// 񓯊̍ĕ`
    void PostUpdate();
    /// 񓯊̍ĕ`
    void PostUpdate(const CRect& rc);
    /// j[o[̍ĕ`
    void UpdateMenubar();

    void SetRect(const CRect& rc) { ::SetWindowPos(m_hWnd, NULL, rc.left, rc.top, rc.GetWidth(), rc.GetHeight(), SWP_NOZORDER); }
    void SetRectClip(const CRect& rc) { SetSize(rc.GetSize()); SetPosClip(rc.GetPoint()); }
    void SetPos(const CPoint& pt) { ::SetWindowPos(m_hWnd, NULL, pt.x, pt.y, 0, 0, SWP_NOZORDER|SWP_NOSIZE); }
    void SetSize(const CSize& sz) { ::SetWindowPos(m_hWnd, NULL, 0, 0, sz.cx, sz.cy, SWP_NOZORDER|SWP_NOMOVE); }
    CPoint GetPos() const;
    CSize GetSize() const;
    CRect GetRect() const { return CRect(GetPos(), GetSize()); }

    //@{ XN[WłPointRect擾
    CPoint GetPosScreen() const { CRect rc; ::GetWindowRect(m_hWnd, &rc); return rc.GetPoint(); }
    CRect GetRectScreen() const { CRect rc; ::GetWindowRect(m_hWnd, &rc); return rc; }
    //@}

    /// ̈ʒuZbg(ʂ͂ݏoȂ悤ɕ␳t)
    void SetPosClip(const CPoint& pt);

    /// ʒ
    void SetCenter();
    /// RECT̒S
    void SetCenter(const CRect& rcRect) { SetPos(rcRect.GetCenterOf(GetSize())); }
    /// RECT̒Sցiʂ͂ݏoȂ悤ɕ␳tj
    void SetCenterClip(const CRect& rcRect) { SetPosClip(rcRect.GetCenterOf(GetSize())); }

    /// NCAg̈̑傫ݒ(j[o[̐܂ԂĂv)
    void SetClientPos(const CPoint& pt) { SetPos(pt - GetPos() - ToScreen(CPoint())); }
    void SetClientPosClip(const CPoint& pt) { SetPosClip(pt - GetPos() - ToScreen(CPoint())); }
    void SetClientSize(const CSize& sz);
    void SetClientRect(const CRect& rc) { SetClientPos(rc.GetPoint()); SetClientSize(rc.GetSize()); }
    void SetClientRectClip(const CRect& rc) { SetClientSize(rc.GetSize()); SetClientPosClip(rc.GetPoint()); }
    CRect GetClientRect() const { return CRect(GetClientPos(), GetClientSize()); }
    CPoint GetClientPos() const { return ToScreen(CPoint()); }
    CSize GetClientSize() const { CRect rc; ::GetClientRect(m_hWnd, &rc); return rc.GetSize(); }
    CPoint ToClient(CPoint pt) const { ::ScreenToClient(m_hWnd, &pt); return pt; }
    CPoint ToScreen(CPoint pt) const { ::ClientToScreen(m_hWnd, &pt); return pt; }

    void SetFocus() { ::SetFocus(m_hWnd); }
    void SetActive() { ::SetActiveWindow(m_hWnd); }
    void SetForeground();
    void SetTopMost(bool bTop = true) { ::SetWindowPos(m_hWnd, bTop? HWND_TOPMOST: HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE); }
    void SetBottomMost(bool bBottom = true) { ::SetWindowPos(m_hWnd, bBottom? HWND_BOTTOM: HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE); }
    /// őOʕ\Ȃ̂ǂB(cł񂩂ˁH(L`))
    bool IsTopMost() const { return (GetExStyle() & WS_EX_TOPMOST) != 0; }

    bool SetCapture() { ::SetCapture(m_hWnd); return ::GetCapture() == GetHandle(); }
    void ReleaseCapture() { ::ReleaseCapture(); }

    BOOL PostMsg(UINT u, WPARAM w, LPARAM l) { return ::PostMessage(m_hWnd, u, w, l); }
    LRESULT SendMsg(UINT u, WPARAM w, LPARAM l) { return ::SendMessage(m_hWnd, u, w, l); }
    void Close() { if (Exists()) SendMsg(WM_CLOSE, 0, 0); }
    void PostClose() { if (Exists()) PostMsg(WM_CLOSE, 0, 0); }
    void CloseForce();

    /// \Ԃݒ
    //
    //  SW_HIDE             \
    //  SW_MAXIMIZE         ő剻
    //  SW_MINIMIZE         ŏ
    //  SW_RESTORE          ŏorő剻̈ʒuƃTCY
    //  SW_SHOW             ANeBuɂČ݂̈ʒuƃTCYŕ\
    //  SW_SHOWDEFAULT      STARTUPINFO \̂ wShowWindow oŎw肳ꂽtO
    //  SW_SHOWMAXIMIZED    ANeBuɂčő剻
    //  SW_SHOWMINIMIZED    ANeBuɂčŏ
    //  SW_SHOWMINNOACTIVE  ANeBuȏԂێŏH
    //  SW_SHOWNA           ANeBuȏԂێ݂̏Ԃŕ\
    //  SW_SHOWNOACTIVATE   ANeBuȏԂێÖʒuƃTCYŕ\
    //  SW_SHOWNORMAL       ŏԂłANeBuɂĕ\
    //
    //  ߂lfalseȂĂ΂O͔\B
    //
    bool Show(int nCmdShow = SW_SHOWNORMAL) { return FALSE != ::ShowWindow(m_hWnd, nCmdShow); }
    bool Hide() { return Show(SW_HIDE); }
    void Minimize() { Show(SW_SHOWMINIMIZED); }
    void Maximize() { Show(SW_SHOWMAXIMIZED); }
    void ShowRestore() { Show(SW_RESTORE); }
    bool IsVisible()  { return (FALSE != ::IsWindowVisible(m_hWnd)); }

    /// ̓ANeBuȂ̂
    bool IsActive() const;
    /// ̓ANeBuȂ̂
    bool IsForeground() const;
    /// ŏĂ̂
    bool IsMinimized() const;
    /// ő剻Ă̂
    bool IsMaximized() const;
    /// ŏő剻ĂȂȂtrue
    bool IsShowNormal() const;

    void SetText(const string& str);
    string GetText() const;

    /// j[o[̉擾(eACẻ̍vF܂ԂsɓWJƂ̒l)
    int GetMenuWidth() const;
    /// j[o[̏c擾(sւ̐܂Ԃl)
    int GetMenuHeight() const;

    /// EBhENX̎擾
    string GetClassName() const;

    /// \[XIDRg[̃nh擾
    HWND GetCtrl(int nId) {
        HWND hCtrl = ::GetDlgItem(GetHandle(), nId);
        Themis_DebugAssertApi(hCtrl != NULL);
        return hCtrl;
    }
    //@{ eRg[̎擾
    CButton Button(int nId) { return GetCtrl(nId); }
    CCheckbox Checkbox(int nId) { return GetCtrl(nId); }
    CCombobox Combobox(int nId) { return GetCtrl(nId); }
    CEditbox Editbox(int nId) { return GetCtrl(nId); }
    CListbox Listbox(int nId) { return GetCtrl(nId); }
    CStatic Static(int nId) { return GetCtrl(nId); }
    CUpdown Updown(int nId) { return GetCtrl(nId); }
    CSlider Slider(int nId) { return GetCtrl(nId); }
    CProgress Progress(int nId) { return GetCtrl(nId); }
    CListview Listview(int nId) { return GetCtrl(nId); }
    CRadios Radios() { return GetHandle(); }
    CRadios Radios(int a, int b) { return CRadios(GetHandle())/a/b; }
    CRadios Radios(int a, int b, int c) { return CRadios(GetHandle())/a/b/c; }
    CRadios Radios(int a, int b, int c, int d) { return CRadios(GetHandle())/a/b/c/d; }
    CRadios Radios(int a, int b, int c, int d, int e) { return CRadios(GetHandle())/a/b/c/d/e; }
    CRadios Radios(int a, int b, int c, int d, int e, int f) { return CRadios(GetHandle())/a/b/c/d/e/f; }
    CRadios Radios(int a, int b, int c, int d, int e, int f, int g) { return CRadios(GetHandle())/a/b/c/d/e/f/g; }
    //@}

    //@{ Ƃ̎ނ̎擾
    EWndCtrlType GetCtrlType(int nId) { return CWnd(GetCtrl(nId)).GetCtrlType(); }
    EWndCtrlType GetCtrlType() const;
    //@}

    //@{ j[̎擾Eݒ
    void DeleteMenu();
    void UnsetMenu();
    void SetMenu(HMENU hMenu);
    void SetMenu(UINT nId);
    HMENU GetMenu() const;
    //@}

    //@{ ACR̎擾Eݒ
    void UnsetIcon();
    void SetIcon(HICON hIcon);
    void SetIcon(UINT nId);
    HICON GetIcon() const;
    //@}

    //@{ wiuV̎擾Eݒ
    void SetBgBlush(HBRUSH hbr);
    HBRUSH GetBgBlush();
    //@}

    //@{ X^C̎擾Eݒ
    void SetStyle(DWORD s);
    void SetExStyle(DWORD s);
    DWORD GetStyle() const;
    DWORD GetExStyle() const;
    //@}

    //@{ e̎擾Eݒ
    void UnsetParent();
    void SetParent(HWND hParent);
    HWND GetParent() const;
    //@}
    /// e̐écƒHĐeȂƂ̂Ԃ
    HWND GetAncestor() const;

    void SetEnableCloseButton(bool b);

    void ShowPopupMenu(HMENU hMenu);
    void ShowPopupMenu(UINT nId);

    int MsgBox(const std::exception& e) { return InnerMsgBox(MB_OK | MB_ICONINFORMATION, L"G[", Encoding::GetDefault().GetString(e.what())); }
    int MsgBox(const string& strCap, const std::exception& e) { return InnerMsgBox(MB_OK | MB_ICONINFORMATION | MB_SYSTEMMODAL, strCap, Encoding::GetDefault().GetString(e.what())); }
    int MsgBox(const string& strCap, const string& strMsg) { return InnerMsgBox(MB_OK | MB_ICONINFORMATION, strCap, strMsg); }
    int MsgBoxOkCancel(const string& strCap, const string& strMsg) { return InnerMsgBox(MB_OKCANCEL | MB_ICONINFORMATION, strCap, strMsg); }
    int MsgBoxYesNo(const string& strCap, const string& strMsg) { return InnerMsgBox(MB_YESNO | MB_ICONQUESTION, strCap, strMsg); }
    int MsgBoxYesNoCancel(const string& strCap, const string& strMsg) { return InnerMsgBox(MB_YESNOCANCEL | MB_ICONQUESTION, strCap, strMsg); }
    int MsgBoxRetryCancel(const string& strCap, const string& strMsg) { return InnerMsgBox(MB_RETRYCANCEL | MB_ICONSTOP, strCap, strMsg); }
    int MsgBoxAbortRetryIgnore(const string& strCap, const string& strMsg) { return InnerMsgBox(MB_ABORTRETRYIGNORE | MB_ICONSTOP, strCap, strMsg); }
    int MsgBox(UINT uType, const string& strCap, const string& strMsg) { return ::MessageBox(m_hWnd, Encoding::GetDefault().GetBytes(strMsg).c_str(), Encoding::GetDefault().GetBytes(strCap).c_str(), uType); }

    HDC GetDC() const { return ::GetDC(m_hWnd); }
    HDC GetWindowDC() const { return ::GetWindowDC(m_hWnd); }
    void ReleaseDC(HDC hDC) { ::ReleaseDC(m_hWnd, hDC); }

    //@{ XN[o[Ă邩ǂAXN[o[NCAg̈̃TCY
    bool IsVisibleHScroll() const;
    bool IsVisibleVScroll() const;
    CSize GetValidClientSize() const;
    //@}

    //@{ IME̕\E\
    void ShowIme();
    void HideIme();
    bool IsShowIme() const;
    //@}

    //@{ ^C}[̐ݒ
    void SetTimer(UINT_PTR nIdEvent, UINT nElapse);
    void UnsetTimer(UINT_PTR nIdEvent);
    //@}

    //@{ 2kȍ~蔼(nAlpha:0  AnAlpha:256  s)
    void SetAlpha(int nAlpha);
    void UnsetAlpha();
    //@}

    //// XPALunaȔwi
    void SetEnableThemeBg(bool bEnable, bool bTab);

    /// WM_PAINTł̕`揈JnɌĂ
    std::tr1::shared_ptr<PAINTSTRUCT> BeginPaint();

    /// t@Chbvo悤ɂ
    void SetAcceptFiles(bool b);
    /// hbvꂽt@C̎擾BWM_DROPFILESĂԂׂB
    vector<CFileName> GetDropedFiles(WPARAM wParam);
    /// t@Chbv(I܂ő҂Ȃ̂ŒӁBSendMessage()Ɖ̂c_no)
    void DropFiles(vector<CFileName>& vctFiles);

    /// nh̎擾
    HWND GetHandle() const { return m_hWnd; }

    /// bZ[WL[̃bZ[ŴĂ(OƂɃbZ[W{bNXƂoĂԂƂ)
    static void RemoveQuitMsg();
    /// QuitbZ[W̔s
    static void PostQuitMsg(int nExitCode = 0) { ::PostQuitMessage(nExitCode); }

//protected:
    void SetHandle(HWND hWnd) { m_hWnd = hWnd; }

private:
    int InnerMsgBox(UINT uType, const string& strCap, const string& strMsg) {
        return MsgBox(uType | MB_SETFOREGROUND, strCap, strMsg);
    }
    //^ꂽNCAg̈𓾂邽߂̗_IȃEBhË擾
    //j[o[̕sւ̐܂Ԃ͖B
    RECT AdjustWindowRect(RECT rcClient) const;

private:
    HWND    m_hWnd;
};

}
