#pragma once
#include "../SerializeBase.h"
namespace Themis {

namespace Detail {
    template<class T, bool bSerializable> class CSerializableSmartObject;
    template<class T> class CSerializableSmartObject<T, false> {};
    template<class T> class CSerializableSmartObject<T, true>: public ISerializable {
        void OnSerialize(ISerializer& r) const { r << **static_cast<const T*>(this); }
        void OnRestore(IRestorer& r)  { r << **static_cast<T*>(this); }
    };
}

/**
    vector<T> ƃRs[RXgN^ȏꍇƂɁA
    vector<smart_obj<T> > ƂĎg肷邽߂̃IuWFNgB

    ܂Astd::set Ƃłg悤ɔrZq`B
    AA̓|C^IȔrł͂ȂAIuWFNgm̔rł鎖ɒӂׂB

    GetPtr()́AIuWFNg̎܂炸QƃJEggꍇɁB
    Ȃ񂠂邩ǂ񂯂ǂB
*/
template<class T, bool bSerializable = false> class smart_obj: public Detail::CSerializableSmartObject<smart_obj<T, bSerializable>, bSerializable> {
public:
    smart_obj(): m_p(new T) {}
    template<class A> smart_obj(const A& a): m_p(new T(a)) {}
    template<class A, class B> smart_obj(const A& a, const B& b): m_p(new T(a, b)) {}
    template<class A, class B, class C> smart_obj(const A& a, const B& b, const C& c): m_p(new T(a, b, c)) {}
    template<class A, class B, class C, class D> smart_obj(const A& a, const B& b, const C& c, const D& d): m_p(new T(a, b, c, d)) {}
    smart_obj(const T& r): m_p(new T(r)) {}
    smart_obj(const smart_obj<T, bSerializable>& r): m_p(r.m_p) {}
 // smart_obj(const smart_obj<T, bSerializable>& r): m_p(new T(*r.m_p)) {}
    ~smart_obj() {}

    //@{ 擾Ƃ(|C^X}[g|C^̐U镑)
    T& operator*() const { return *m_p; }
    T* operator->() const { return m_p.get(); }
    T& Get() const { return *m_p; }
    const std::tr1::shared_ptr<T>& GetPtr() const { return m_p; }
    //@}

    //@{ rZq(T^̃IuWFNgۂU镑)
    template<class U, bool V> inline bool operator==(const smart_obj<U,V>& r) const { return Get() == *r; }
    template<class U, bool V> inline bool operator!=(const smart_obj<U,V>& r) const { return Get() != *r; }
    template<class U, bool V> inline bool operator<=(const smart_obj<U,V>& r) const { return Get() <= *r; }
    template<class U, bool V> inline bool operator>=(const smart_obj<U,V>& r) const { return Get() >= *r; }
    template<class U, bool V> inline bool operator<(const smart_obj<U,V>& r) const { return Get() < *r; }
    template<class U, bool V> inline bool operator>(const smart_obj<U,V>& r) const { return Get() > *r; }
    inline bool operator==(const smart_obj<T, bSerializable>& r) const { return Get() == *r; }
    inline bool operator!=(const smart_obj<T, bSerializable>& r) const { return Get() != *r; }
    inline bool operator<=(const smart_obj<T, bSerializable>& r) const { return Get() <= *r; }
    inline bool operator>=(const smart_obj<T, bSerializable>& r) const { return Get() >= *r; }
    inline bool operator<(const smart_obj<T, bSerializable>& r) const { return Get() < *r; }
    inline bool operator>(const smart_obj<T, bSerializable>& r) const { return Get() > *r; }
    //@}

private:
    std::tr1::shared_ptr<T> m_p;
};



}
