#include "stdafx.h"
#include <Themis/WndCtrlData.h>
#include <Themis/CommDlg.h>
#include <Themis/KeyTable.h>
#include <Themis/Tooltip.h>
#include <Themis/CtrlEnable.h>
#include <Themis/using.h>
#include "resource.h"
#include "Dialogs.h"

CConfigDialog::CConfigDialog(CConfig& r) : CResourceDialogBase(IDD_CONFIG), m_oConfig(r) {
}

CConfigDialog::~CConfigDialog() {
}

bool CConfigDialog::HookMsg(CMsgHookPrms& rPrms) {
    if (rPrms.GetMsg() == WM_COMMAND) {
        switch (rPrms.GetWPrmLoWord()) {
        case IDOK:
            SaveToConfig();
            GetDialog().SetResult(DialogResult::OK);
            GetDialog().Close();
            break;
        case IDCANCEL:
            GetDialog().SetResult(DialogResult::Cancel);
            GetDialog().Close();
            break;
        case IDC_BUTTON1:
            {
                CKeyDialog oDlg;
                oDlg.SetKey(GetDialog().Editbox(IDC_EDIT1).GetText());
                oDlg.Open(GetDialog().GetHandle());
                if (oDlg.IsOK()) {
                    GetDialog().Editbox(IDC_EDIT1).SetText(oDlg.GetKey());
                }
            }
            break;
        case IDC_BUTTON2:
            {
                CKeyDialog oDlg;
                oDlg.SetKey(GetDialog().Editbox(IDC_EDIT2).GetText());
                oDlg.Open(GetDialog().GetHandle());
                if (oDlg.IsOK()) {
                    GetDialog().Editbox(IDC_EDIT2).SetText(oDlg.GetKey());
                }
            }
            break;
        case IDC_BUTTON3:
            {
                CKeyDialog oDlg;
                oDlg.SetKey(GetDialog().Editbox(IDC_EDIT3).GetText());
                oDlg.Open(GetDialog().GetHandle());
                if (oDlg.IsOK()) {
                    GetDialog().Editbox(IDC_EDIT3).SetText(oDlg.GetKey());
                }
            }
            break;
        case IDC_CHECK1:
        case IDC_CHECK8:
            UpdateEnableCtrl();
            break;
        case IDC_BUTTON4:
            {
                CChooseFile oChooseFile;
                oChooseFile.SetOwner(rPrms.GetWnd());
                oChooseFile.SetTitle(L"t@CI_CAO");
                oChooseFile.ClearNameFilter();
                oChooseFile.AddNameFilter(L"wavt@C", L"*.wav");
                oChooseFile.AddNameFilter(L"SẴt@C", L"*.*");
                oChooseFile.SetCurrentDir(CFileName(CFileNameModuleDir(GetDialog().Editbox(IDC_EDIT6).GetText()).GetDir()));
                oChooseFile.SetDefaultExt(L"wav");
                oChooseFile.SetDefault(CFileNameModuleDir(GetDialog().Editbox(IDC_EDIT6).GetText()).GetPureName());
                if (oChooseFile.ShowOpen()) {
                    GetDialog().Editbox(IDC_EDIT6).SetText(oChooseFile.GetResult().Get());
                }
            }
            break;
        }
        return false;
    } else if (rPrms.GetMsg() == WM_INITDIALOG) {
        LoadFromConfig();
        UpdateEnableCtrl();
        // [邿ՁB
        CDialogTooltip* pTip = new CDialogTooltip(GetDialog());
        pTip->Add(IDC_CHECK2, L"Nbv{[hĎA摜܂ꂽۑ@\Lɂ܂B");
        pTip->Add(IDC_CHECK1, L"zbgL[ɂʎ荞݂Lɂ܂B");
        pTip->Add(IDC_EDIT1, L"ʑŜ荞ރzbgL[w肵܂B");
        pTip->Add(IDC_EDIT2, L"ANeBuEBhE荞ރzbgL[w肵܂B");
        pTip->Add(IDC_EDIT3, L"ANeBuEBhẼNCAg̈荞ރzbgL[w肵܂B");
        pTip->Add(IDC_CHECK6, L"zbgL[ɂʎ荞ݎɃJ[\܂߂ăLv`[܂B");
        pTip->Add(IDC_CHECK9, L"ȃEBhEȂǂ荞݂܂B");
        pTip->Add(IDC_EDIT4, L"t@C̏w肵܂B\r\n΃pX̏ꍇAfXNgbvƂȂ܂B\r\n΃pXϐgp\łB");
        pTip->Add(IDC_RADIO1, L"PNG`ŉ摜ۑ܂B");
        pTip->Add(IDC_RADIO2, L"JPG`ŉ摜ۑ܂B");
        pTip->Add(IDC_RADIO3, L"BMP`ŉ摜ۑ܂B");
        pTip->Add(IDC_EDIT5, L"JPGۑ̕iŎw肵܂B");
        pTip->Add(IDC_EDIT7, L"PNGۑ̈kxw肵܂BftHg 6 łB");
        pTip->Add(IDC_CHECK7, L"摜̕ۑIɃr[v炵܂B");
        pTip->Add(IDC_CHECK8, L"摜̕ۑIwavt@CĐ܂B");
        pTip->Add(IDC_EDIT6, L"Đwavt@Cw肵܂B");
        pTip->Add(IDC_BUTTON4, L"t@CI_CAOJ܂B");
        pTip->Add(IDC_RADIO4, L"^XNgC̃ACR_uNbNƂɉ摜̕ۑtH_J܂B");
        pTip->Add(IDC_RADIO5, L"^XNgC̃ACR_uNbNƂɐݒ_CAOJ܂B");
        pTip->Add(IDC_RADIO6, L"^XNgC̃ACR_uNbNƂɉʑŜ荞݂܂B");
        return true;
    } else if (rPrms.GetMsg() == WM_CLOSE) {
        GetDialog().Delete();
        return true;
    } else {
        return false;
    }
}

void CConfigDialog::UpdateEnableCtrl() {
    CCtrlEnable(GetDialog().Checkbox(IDC_CHECK1).GetCheck())
        << GetDialog().GetCtrl(IDC_EDIT1)
        << GetDialog().GetCtrl(IDC_BUTTON1)
        << GetDialog().GetCtrl(IDC_EDIT2)
        << GetDialog().GetCtrl(IDC_BUTTON2)
        << GetDialog().GetCtrl(IDC_EDIT3)
        << GetDialog().GetCtrl(IDC_BUTTON3);
    CCtrlEnable(GetDialog().Checkbox(IDC_CHECK8).GetCheck())
        << GetDialog().GetCtrl(IDC_EDIT6)
        << GetDialog().GetCtrl(IDC_BUTTON4);
}

void CConfigDialog::LoadFromConfig() {
    m_oConfig.BoolData(L"WatchClipboard") >> CCheckboxData(GetDialog(), IDC_CHECK2);
    m_oConfig.BoolData(L"KeyHook_") >> CCheckboxData(GetDialog(), IDC_CHECK1);
    m_oConfig.IndirectData(L"KeyHook0") >> CEditboxData(GetDialog(), IDC_EDIT1);
    m_oConfig.IndirectData(L"KeyHook1") >> CEditboxData(GetDialog(), IDC_EDIT2);
    m_oConfig.IndirectData(L"KeyHook2") >> CEditboxData(GetDialog(), IDC_EDIT3);
    m_oConfig.BoolData(L"CaptureCursor") >> CCheckboxData(GetDialog(), IDC_CHECK6);
    m_oConfig.BoolData(L"CaptureLayer") >> CCheckboxData(GetDialog(), IDC_CHECK9);
    m_oConfig.FileData(L"FileNameFormat") >> CEditboxData(GetDialog(), IDC_EDIT4);
    m_oConfig.NumData(L"SaveType") >> CRadiosData(GetDialog(), IDC_RADIO1, IDC_RADIO2, IDC_RADIO3);
    m_oConfig.NumData(L"JpgQuality(%)") >> CEditboxData(GetDialog(), IDC_EDIT5);
    m_oConfig.NumData(L"PngCompress") >> CEditboxData(GetDialog(), IDC_EDIT7);
    m_oConfig.BoolData(L"NotifyBeep") >> CCheckboxData(GetDialog(), IDC_CHECK7);
    m_oConfig.BoolData(L"NotifyWav") >> CCheckboxData(GetDialog(), IDC_CHECK8);
    m_oConfig.FileData(L"NotifyWavFile") >> CEditboxData(GetDialog(), IDC_EDIT6);
    m_oConfig.NumData(L"DoubleClick") >> CRadiosData(GetDialog(), IDC_RADIO4, IDC_RADIO5, IDC_RADIO6);
}

void CConfigDialog::SaveToConfig() {
    m_oConfig.BoolData(L"WatchClipboard") << CCheckboxData(GetDialog(), IDC_CHECK2);
    m_oConfig.BoolData(L"KeyHook_") << CCheckboxData(GetDialog(), IDC_CHECK1);
    m_oConfig.IndirectData(L"KeyHook0") << CEditboxData(GetDialog(), IDC_EDIT1);
    m_oConfig.IndirectData(L"KeyHook1") << CEditboxData(GetDialog(), IDC_EDIT2);
    m_oConfig.IndirectData(L"KeyHook2") << CEditboxData(GetDialog(), IDC_EDIT3);
    m_oConfig.BoolData(L"CaptureCursor") << CCheckboxData(GetDialog(), IDC_CHECK6);
    m_oConfig.BoolData(L"CaptureLayer") << CCheckboxData(GetDialog(), IDC_CHECK9);
    m_oConfig.FileData(L"FileNameFormat") << CEditboxData(GetDialog(), IDC_EDIT4);
    m_oConfig.NumData(L"SaveType") << CRadiosData(GetDialog(), IDC_RADIO1, IDC_RADIO2, IDC_RADIO3);
    m_oConfig.NumData(L"JpgQuality(%)") << CEditboxData(GetDialog(), IDC_EDIT5);
    m_oConfig.NumData(L"PngCompress") << CEditboxData(GetDialog(), IDC_EDIT7);
    m_oConfig.BoolData(L"NotifyBeep") << CCheckboxData(GetDialog(), IDC_CHECK7);
    m_oConfig.BoolData(L"NotifyWav") << CCheckboxData(GetDialog(), IDC_CHECK8);
    m_oConfig.FileData(L"NotifyWavFile") << CEditboxData(GetDialog(), IDC_EDIT6);
    m_oConfig.NumData(L"DoubleClick") << CRadiosData(GetDialog(), IDC_RADIO4, IDC_RADIO5, IDC_RADIO6);
}

//----------------------------------------------------------------//

CKeyDialog::CKeyDialog() : CResourceDialogBase(IDD_KEY) {
}

CKeyDialog::~CKeyDialog() {
}

bool CKeyDialog::HookMsg(CMsgHookPrms& rPrms) {
    if (rPrms.GetMsg() == WM_COMMAND) {
        switch (rPrms.GetWPrmLoWord()) {
        case IDOK:
            {
                int nModifiers = 0;
                if (GetDialog().Checkbox(IDC_CHECK1).GetCheck()) { nModifiers = CKeyTable::eModCtrl; }
                if (GetDialog().Checkbox(IDC_CHECK3).GetCheck()) { nModifiers |= CKeyTable::eModAlt; }
                if (GetDialog().Checkbox(IDC_CHECK4).GetCheck()) { nModifiers |= CKeyTable::eModShift; }
                if (GetDialog().Checkbox(IDC_CHECK5).GetCheck()) { nModifiers |= CKeyTable::eModWin; }
                CKeyTable::EKey eKey = (CKeyTable::EKey)GetDialog().Combobox(IDC_COMBO1).GetSelected();
                m_strKey = CKeyTable::GetKeyName(eKey, nModifiers);
            }
            m_bOK = true;
            GetDialog().Close();
            break;
        case IDCANCEL:
            GetDialog().Close();
            break;
        }
        return false;
    } else if (rPrms.GetMsg() == WM_INITDIALOG) {
        CCombobox oCombo(GetDialog().GetCtrl(IDC_COMBO1));
        for (int i = 0; i < CKeyTable::eKeyNumDiv; i++) {
            oCombo.Add(CKeyTable::GetKeyName(CKeyTable::EKey(i)));
        }
        pair<CKeyTable::EKey, int> p = CKeyTable::GetKey(m_strKey);
        oCombo.SetSelected(p.first);
        GetDialog().Checkbox(IDC_CHECK1).SetCheck((p.second & CKeyTable::eModCtrl) != 0);
        GetDialog().Checkbox(IDC_CHECK3).SetCheck((p.second & CKeyTable::eModAlt) != 0);
        GetDialog().Checkbox(IDC_CHECK4).SetCheck((p.second & CKeyTable::eModShift) != 0);
        GetDialog().Checkbox(IDC_CHECK5).SetCheck((p.second & CKeyTable::eModWin) != 0);
        return true;
    } else if (rPrms.GetMsg() == WM_CLOSE) {
        GetDialog().Delete();
        return true;
    } else {
        return false;
    }
}

